#include <iostream>
#include <iomanip>
#include "material.h"

using namespace std;

const int pawnopen[64] = {
    0	,	0	,	0	,	-5	,	-5	,	0	,	0	,	0	,
	-10	,	-5	,	0	,	0	,	0	,	0	,	-5	,	-10	,
	-10	,	-5	,	0	,	5	,	5	,	0	,	-5	,	-10	,
	-10	,	-5	,	0	,	5	,	5	,	0	,	-5	,	-10	,
	-10	,	-5	,	0	,	3	,	3	,	0	,	-5	,	-10	,
	-10	,	-5	,	0	,	0	,	0	,	0	,	-5	,	-10	,
	-10	,	-5	,	0	,	0	,	0	,	0	,	-5	,	-10	,
	0	,	0	,	0	,	0	,	0	,	0	,	0	,	0
};


const int pawnend[64] = {
    0	,	0	,	0	,	-5	,	-5	,	0	,	0	,	0	,
	-16	,	-11	,	-5	,	-5	,	-5	,	-5	,	-11	,	-16	,
	-13	,	-8	,	-2	,	-2	,	-2	,	-2	,	-8	,	-13	,
	-10	,	-5	,	1	,	1	,	1	,	1	,	-5	,	-10	,
	-7	,	-2	,	4	,	4	,	4	,	4	,	-2	,	-7	,
	-4	,	1	,	7	,	7	,	7	,	7	,	1	,	-4	,
	-1	,	4	,	10	,	10	,	10	,	10	,	4	,	-1	,
	0	,	0	,	0	,	0	,	0	,	0	,	0	,	0
};

const int rookopen[64] = {
    0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0	,
	0	,	0	,	0	,	3	,	3	,	0	,	0	,	0
	};
const int kingopen[64] = {
    10	,	15	,	0	,	0	,	0	,	10	,	10	,	5	,
	0	,	0	,	0	,	0	,	0	,	0	,	0	,	0	,
	-30	,	-30	,	-30	,	-30	,	-30	,	-30	,	-30	,	-30	,
	-40	,	-40	,	-40	,	-40	,	-40	,	-40	,	-40	,	-40	,
	-50	,	-50	,	-50	,	-50	,	-50	,	-50	,	-50	,	-50	,
	-60	,	-60	,	-60	,	-60	,	-60	,	-60	,	-60	,	-60	,
	-70	,	-70	,	-70	,	-70	,	-70	,	-70	,	-70	,	-70	,
	-80	,	-80	,	-80	,	-80	,	-80	,	-80	,	-80	,	-80
};

const int kingend[64] = {
    -50	,	-25	,	-20	,	-20	,	-20	,	-20	,	-25	,	-50	,
	-25	,	0	,	0	,	0	,	0	,	0	,	0	,	-25	,
	-20	,	0	,	5	,	5	,	5	,	5	,	0	,	-20	,
	-20	,	0	,	5	,	10	,	10	,	5	,	0	,	-20	,
	-20	,	0	,	5	,	10	,	10	,	5	,	0	,	-20	,
	-20	,	0	,	5	,	5	,	5	,	5	,	0	,	-20	,
	-25	,	0	,	0	,	0	,	0	,	0	,	0	,	-25	,
	-50	,	-25	,	-20	,	-20	,	-20	,	-20	,	-25	,	-50
};



void cMaterial::init_psqt()
{
uint pce,ph,e,i,sq,oppsq;

	for(pce = 0; pce < numpieces; ++pce)
		for(ph = 0; ph < 2; ++ph)
			for(e = 0; e < BRDSQ; ++e)
				psqt[pce][ph][e] = 0;

	for(pce = pwP; pce < numpieces; pce+=2)
	{
      ASS(whitepce(pce));
		for(i = 0; i < 64; ++i)
		{
              sq = sqfrom64(i);
              ASS(onbrd(sq));
              switch(pce)
              {
                case pwP:
                psqt[pce][0][sq] = pawnopen[i];
                psqt[pce][1][sq] = pawnend[i];
                break;
                case pwN:
                psqt[pce][0][sq] = kingend[i];
                psqt[pce][1][sq] = kingend[i];
                break;
                case pwR:
				psqt[pce][0][sq] = rookopen[i];
                psqt[pce][1][sq] = rookopen[i];
                break;
                case pwK:
                psqt[pce][0][sq] = kingopen[i];
                psqt[pce][1][sq] = kingend[i];
                break;
                default: break;
			  }
          }
    }


  //fill black tables
  for(i = 0; i < 64; ++i)
  {
    sq = sqfrom64(i);
    oppsq = sqrev[sq];
    ASS(onbrd(oppsq));
    ASS(onbrd(sq));
    for(pce = pbP; pce < numpieces; pce+=2)
	{
      ASS(blackpce(pce));
      {
         ASS(whitepce(pce-1));
         psqt[pce][0][oppsq] = psqt[pce-1][0][sq];
         psqt[pce][1][oppsq] = psqt[pce-1][1][sq];
      }
    }
  }
/*
#ifdef DEBUG
cout<<"\n\n"; uint f = 0;
    int  r = 0;
   // uint sq;


for(pce = 0; pce < numpieces; ++pce)
{
        cout<<endl;
        cout<<"\n piece sq opening "<<piecechar(pce)<<endl;
    for( r = 7; r>=0; r--)
    {
        for( f = 0; f<=7; ++f)
        {
           sq = fr2sq(f,r);
           ASS(onbrd(sq));
           cout<<setw(5)<<psqt[pce][0][sq];
        }
        cout<<endl;
    }
}


for(pce = 0; pce < numpieces; ++pce)
{
        cout<<endl;
        cout<<"\n piece end "<<piecechar(pce)<<endl;
    for( r = 7; r>=0; r--)
    {
        for( f = 0; f<=7; ++f)
        {
           sq = fr2sq(f,r);
           ASS(onbrd(sq));
           cout<<setw(5)<<psqt[pce][1][sq];
        }
        cout<<endl;
    }
}
#endif
*/
}

void cMaterial::movepsqt(uint pce, uint from, uint to)
{
     ASS(onbrd(from));
     ASS(onbrd(to));
     ASS(piecegood(pce));

     uint colour = pcecolour(pce);

     ASS(colour==cW || colour==cB);
     psqvalope[colour] += (psqt[pce][OPE][to]-psqt[pce][OPE][from]);
     psqvalend[colour] += (psqt[pce][END][to]-psqt[pce][END][from]);
}

void cMaterial::addpsqt(uint pce, uint sq)
{
     ASS(onbrd(sq));
     ASS(piecegood(pce));

     uint colour = pcecolour(pce);

     ASS(colour==cW || colour==cB);
     psqvalope[colour] += psqt[pce][OPE][sq];
     psqvalend[colour] += psqt[pce][END][sq];;
}

void cMaterial::removepsqt(uint pce, uint sq)
{
     ASS(onbrd(sq));
     ASS(piecegood(pce));

     uint colour = pcecolour(pce);

     ASS(colour==cW || colour==cB);
     psqvalope[colour] -= psqt[pce][OPE][sq];
     psqvalend[colour] -= psqt[pce][END][sq];
}

//need to predefine statics in a class..... easier way to do this?
int cMaterial::psqt[numpieces][2][BRDSQ] = {
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    },
    {
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       },
       {
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       }
    }
};
