#ifndef ENGINE_H
#define ENGINE_H

#include "searcher.h"

struct SEngineOpt {
    uint engineside;
    uint moves;
    bool ponder;
    bool analyzemode;
};

const uint FORCESIDE = 3;

class cEngine {

private:

    uint pondermove;

   //xboard functions
	void sayfeatures();
	void startxboard();
	bool parse_move(string move);
	void xboardlevel(string str, int pos);
	bool checkresult();
	void xboard_think();
    void xboard_ponder();
	//uci functions
	void sayversion();
	void initucioptions();
	void uciposition(string line);
	void init_go();
	void setucioptions(string input);
	void sayucioptions();
	void uci_go(string command);


public: //all public for the moment

    cSearcher tree;


    //xboard
	SEngineOpt options;
	void process_xboard();

	//uci
	void process_uci();
};


#endif

